<template>
  <b-modal
    :title="title"
    ref="myModalRef"
    ok-title="保存"
    @ok="handleOk"
    @cancel="clearName"
    cancel-title="取消"
    :hide-header="!title"
    :hide-footer="isShowFooter"
  >
    <div>
      <Tree
        ref="tree"
        :data="treeData"
        :isOpenAll="false"
        :currentId="currentId"
        @currentNode="currentNode"
        @check-change="({list,ids})=>{checkedList=list;checkedIds=ids}"
        :showCheckbox="true"
      />
    </div>
  </b-modal>
</template>

<script>
import Tree from './Tree'
export default {
  props: {
    title: String,
    item: Object,
    treeData: {
      default: []
    },
    isShowFooter: {
      default: false
    }
  },
  data: () => ({
    name: '',
    currentOrgItem: null,
    currentId: '',
    checkedList: [],
    checkedIds: []
  }),
  methods: {
    // * 打开modal
    showModel() {
      this.$refs.myModalRef.show()
      console.log(this.treeData, 'this.treeData')
      this.$nextTick(() => {
        this.reView(this.item)
      })
    },
    hideModel() {
      this.$refs.myModalRef.hide()
    },
    // * 组织机构数点击回调
    currentNode(node) {
      this.currentOrgItem = node
      this.currentId = node.id
      if (this.isShowFooter) {
        this.$emit('submit', {
          node: this.currentOrgItem,
          id: this.currentId
        })
      }
    },
    // 回显
    reView(item) {
      console.log(item, 'item----')
      if (item) {
        this.currentOrgItem = item
        this.currentId = item.id
        /* 设置选中项 */
        this.$refs.tree.setCurrentKey(item.id)
      } else {
        this.currentOrgItem = null
        this.currentId = ''
        /*  清空  */
        this.$refs.tree.removeCurrentNode()
      }
    },
    // * 提交表单
    handleOk(e) {
      e.preventDefault()
      if (!this.currentOrgItem || this.checkedList.length === 0) {
        this.$toast({
          type: 'error',
          message: '请选择节点'
        })
        return
      }
      this.$emit('submit', {
        node: this.currentOrgItem,
        id: this.currentId,
        list: this.checkedList,
        ids: this.checkedIds
      })
    },
    // * 取消
    clearName() {},
    handleCheckChange(data) {
      console.log(data, 'data')
    }
  },
  components: {
    Tree
  }
}
</script>
